# Deutschlandatlas
Der [Deutschlandatlas](https://www.deutschlandatlas.bund.de/DE/Home/home_node.html) ist ein Internetangebot, herausgegeben vom Bundesministerium für Wohnen, Stadtentwicklung und Bauwesen. Dort finden sich interaktive Karten zu gleichwertigen Lebensverhältnissen auf Grundlage aktueller verfügbarer Daten.
Informationen zu allen [Indikatoren](https://www.deutschlandatlas.bund.de/DE/Service/Downloads/Indikatoren_Deutschlandatlas.html) sowie aktuelle Daten in [tabellarischer Form](https://www.deutschlandatlas.bund.de/DE/Service/Downloads/downloads_node.html) stehen online zum Download bereit.


This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 0.1.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python >= 3.6

## Installation & Usage
### pip install

```sh
pip install deutschland[Deutschlandatlas]
```

### poetry install

```sh
poetry add deutschland -E Deutschlandatlas
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

## Usage

Import the package:
```python
from deutschland import Deutschlandatlas
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
from deutschland import Deutschlandatlas
from pprint import pprint
from deutschland.Deutschlandatlas.api import default_api
# Defining the host is optional and defaults to https://www.karto365.de/hosting/rest/services
# See configuration.py for a list of all supported configuration parameters.
configuration = Deutschlandatlas.Configuration(
    host = "https://www.karto365.de/hosting/rest/services"
)



# Enter a context with an instance of the API client
with Deutschlandatlas.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = default_api.DefaultApi(api_client)
    table = "p_apo_f_ZA2022" # str |  Angaben zu allen online vorliegenden Tabellen finden sich [hier](https://www.karto365.de/portal/sharing/rest/search?q=deutschlandatlas&f=json&num=100&start=1) und [hier](https://www.karto365.de/portal/sharing/rest/search?q=deutschlandatlas&f=json&num=100&start=101)  (default to "p_apo_f_ZA2022")
    where = "1%3D1" # str | Spezifikation einer gewünschten Teilmenge der Daten (z.B.'1=1'). (default to "1%3D1")
    f = "json" # str | Output-Format (z.B. 'json' oder 'html').
    out_fields = "*" # str | Auszugebende Variablen/fields (z.B. '*'). (optional)
    return_geometry = False # bool | Boolsche Angabe, ob Angaben zur Geometrie gesendet werden sollen (z.B. 'false'). (optional)
    spatial_rel = "esriSpatialRelIntersects" # str | spational relation (z.B. 'esriSpatialRelIntersects'). (optional)

    try:
        # query
        api_response = api_instance.query(table, where, f, out_fields=out_fields, return_geometry=return_geometry, spatial_rel=spatial_rel)
        pprint(api_response)
    except Deutschlandatlas.ApiException as e:
        print("Exception when calling DefaultApi->query: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://www.karto365.de/hosting/rest/services*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**query**](docs/DefaultApi.md#query) | **GET** /{table}/MapServer/0/query | query


## Documentation For Models



## Documentation For Authorization

 All endpoints do not require authorization.

## Author

kontakt@bund.dev


## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in Deutschlandatlas.apis and Deutschlandatlas.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from deutschland.Deutschlandatlas.api.default_api import DefaultApi`
- `from deutschland.Deutschlandatlas.model.pet import Pet`

Solution 2:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
from deutschland import Deutschlandatlas
from deutschland.Deutschlandatlas.apis import *
from deutschland.Deutschlandatlas.models import *
```

