"""
    Deutschlandatlas-API

    Der [Deutschlandatlas](https://www.deutschlandatlas.bund.de/DE/Home/home_node.html) ist ein Internetangebot, herausgegeben vom Bundesministerium für Wohnen, Stadtentwicklung und Bauwesen. Dort finden sich interaktive Karten zu gleichwertigen Lebensverhältnissen auf Grundlage aktueller verfügbarer Daten. Informationen zu allen [Indikatoren](https://www.deutschlandatlas.bund.de/DE/Service/Downloads/Indikatoren_Deutschlandatlas.html) sowie aktuelle Daten in [tabellarischer Form](https://www.deutschlandatlas.bund.de/DE/Service/Downloads/downloads_node.html) stehen online zum Download bereit.   # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: kontakt@bund.dev
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from deutschland.Deutschlandatlas.api_client import ApiClient
from deutschland.Deutschlandatlas.api_client import Endpoint as _Endpoint
from deutschland.Deutschlandatlas.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types,
)


class DefaultApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.query_endpoint = _Endpoint(
            settings={
                "response_type": (
                    {
                        str: (
                            bool,
                            date,
                            datetime,
                            dict,
                            float,
                            int,
                            list,
                            str,
                            none_type,
                        )
                    },
                ),
                "auth": [],
                "endpoint_path": "/{table}/MapServer/0/query",
                "operation_id": "query",
                "http_method": "GET",
                "servers": None,
            },
            params_map={
                "all": [
                    "table",
                    "where",
                    "f",
                    "out_fields",
                    "return_geometry",
                    "spatial_rel",
                ],
                "required": [
                    "table",
                    "where",
                    "f",
                ],
                "nullable": [],
                "enum": [],
                "validation": [],
            },
            root_map={
                "validations": {},
                "allowed_values": {},
                "openapi_types": {
                    "table": (str,),
                    "where": (str,),
                    "f": (str,),
                    "out_fields": (str,),
                    "return_geometry": (bool,),
                    "spatial_rel": (str,),
                },
                "attribute_map": {
                    "table": "table",
                    "where": "where",
                    "f": "f",
                    "out_fields": "outFields",
                    "return_geometry": "returnGeometry",
                    "spatial_rel": "spatialRel",
                },
                "location_map": {
                    "table": "path",
                    "where": "query",
                    "f": "query",
                    "out_fields": "query",
                    "return_geometry": "query",
                    "spatial_rel": "query",
                },
                "collection_format_map": {},
            },
            headers_map={
                "accept": ["application/json"],
                "content_type": [],
            },
            api_client=api_client,
        )

    def query(self, f, table="p_apo_f_ZA2022", where="1%3D1", **kwargs):
        """query  # noqa: E501

        Im JSON-Format lassen sich aktuelle und historische Daten zu ausgewählten Indikatoren über GET-requests folgender Machart erhalten   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.query(f, table="p_apo_f_ZA2022", where="1%3D1", async_req=True)
        >>> result = thread.get()

        Args:
            f (str): Output-Format (z.B. 'json' oder 'html').
            table (str):  Angaben zu allen online vorliegenden Tabellen finden sich [hier](https://www.karto365.de/portal/sharing/rest/search?q=deutschlandatlas&f=json&num=100&start=1) und [hier](https://www.karto365.de/portal/sharing/rest/search?q=deutschlandatlas&f=json&num=100&start=101) . defaults to "p_apo_f_ZA2022", must be one of ["p_apo_f_ZA2022"]
            where (str): Spezifikation einer gewünschten Teilmenge der Daten (z.B.'1=1').. defaults to "1%3D1", must be one of ["1%3D1"]

        Keyword Args:
            out_fields (str): Auszugebende Variablen/fields (z.B. '*').. [optional]
            return_geometry (bool): Boolsche Angabe, ob Angaben zur Geometrie gesendet werden sollen (z.B. 'false').. [optional]
            spatial_rel (str): spational relation (z.B. 'esriSpatialRelIntersects').. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            {str: (bool, date, datetime, dict, float, int, list, str, none_type)}
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs["async_req"] = kwargs.get("async_req", False)
        kwargs["_return_http_data_only"] = kwargs.get("_return_http_data_only", True)
        kwargs["_preload_content"] = kwargs.get("_preload_content", True)
        kwargs["_request_timeout"] = kwargs.get("_request_timeout", None)
        kwargs["_check_input_type"] = kwargs.get("_check_input_type", True)
        kwargs["_check_return_type"] = kwargs.get("_check_return_type", True)
        kwargs["_spec_property_naming"] = kwargs.get("_spec_property_naming", False)
        kwargs["_content_type"] = kwargs.get("_content_type")
        kwargs["_host_index"] = kwargs.get("_host_index")
        kwargs["_request_auths"] = kwargs.get("_request_auths", None)
        kwargs["table"] = table
        kwargs["where"] = where
        kwargs["f"] = f
        return self.query_endpoint.call_with_http_info(**kwargs)
